import { jsx as a } from "react/jsx-runtime";
import { useFloating as E, useClick as _, useDismiss as C, useRole as R, useInteractions as x, useMergeRefs as P, FloatingPortal as k, FloatingOverlay as y, FloatingFocusManager as F } from "@floating-ui/react";
import S from "clsx";
import * as o from "react";
import { useId as h } from "react";
const I = o.createContext(null);
function D({
  initialOpen: n = !1,
  open: i,
  onOpenChange: t
} = {}) {
  const [e, r] = o.useState(n), [s, l] = o.useState(), [c, b] = o.useState(), u = i ?? e, f = t ?? r, p = E({
    open: u,
    onOpenChange: f
  }), m = p.context, w = _(m, {
    enabled: i == null
  }), M = C(m, {
    outsidePress: !1,
    outsidePressEvent: "mousedown"
  }), v = R(m), g = x([w, M, v]);
  return o.useMemo(
    () => ({
      open: u,
      setOpen: f,
      ...g,
      ...p,
      labelId: s,
      descriptionId: c,
      setLabelId: l,
      setDescriptionId: b
    }),
    [u, f, g, p, s, c]
  );
}
const d = () => {
  const n = o.useContext(I);
  if (n == null)
    throw new Error("Modal components must be wrapped in <Modal />");
  return n;
};
function $({
  children: n,
  ...i
}) {
  const t = D(i);
  return /* @__PURE__ */ a(I.Provider, { value: t, children: n });
}
const V = o.forwardRef(function(n, i) {
  const { context: t, ...e } = d(), r = P([e.refs.setFloating, i]);
  if (!t.open)
    return null;
  const { overlayBackground: s, ...l } = n, c = S("grid place-items-center", {
    [`${s}`]: s,
    "bg-black sm:bg-black/[.8]": !s
  });
  return /* @__PURE__ */ a(k, { children: /* @__PURE__ */ a(y, { className: c, lockScroll: !0, children: /* @__PURE__ */ a(F, { context: t, children: /* @__PURE__ */ a(
    "div",
    {
      ref: r,
      "aria-labelledby": e.labelId,
      "aria-describedby": e.descriptionId,
      ...e.getFloatingProps(l),
      children: l.children
    }
  ) }) }) });
}), A = o.forwardRef(function({ children: n, ...i }, t) {
  const { setLabelId: e } = d(), r = h();
  return o.useLayoutEffect(() => (e(r), () => e(void 0)), [r, e]), /* @__PURE__ */ a("h1", { ...i, ref: t, id: r, children: n });
}), U = o.forwardRef(function({ children: n, ...i }, t) {
  const { setDescriptionId: e } = d(), r = h();
  return o.useLayoutEffect(() => (e(r), () => e(void 0)), [r, e]), /* @__PURE__ */ a("div", { ...i, ref: t, id: r, children: n });
}), j = o.forwardRef(function(n, i) {
  const { setOpen: t } = d(), { trigger: e, className: r, ...s } = n, l = o.useCallback(() => t(!1), [t]);
  return /* @__PURE__ */ a("div", { className: r, children: o.cloneElement(e, {
    ref: i,
    onClick: l,
    ...s
  }) });
});
/*!
  @versini/ui-private v1.8.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_PRIVATE__ || (window.__VERSINI_UI_PRIVATE__ = {
    version: "1.8.0",
    buildTime: "12/25/2024 12:30 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
export {
  $ as Modal,
  j as ModalClose,
  V as ModalContent,
  U as ModalDescription,
  A as ModalHeading
};
